From dc4816142c7f628e2828b09b7634e1c65be7e823 Mon Sep 17 00:00:00 2001
From: Karel Zak <kzak@redhat.com>
Date: Mon, 10 Aug 2020 12:00:17 +0200
Subject: [PATCH] tests: add sfdisk test for
 4fe7f9b614e2b5bb97f6d89af02acb867cffccc1

Signed-off-by: Karel Zak <kzak@redhat.com>
---
 tests/expected/sfdisk/dos-sizes-vs-gaps | 26 +++++++++++++++++++++++++
 tests/ts/sfdisk/dos                     | 13 +++++++++++++
 2 files changed, 39 insertions(+)
 create mode 100644 tests/expected/sfdisk/dos-sizes-vs-gaps

diff --git a/tests/expected/sfdisk/dos-sizes-vs-gaps b/tests/expected/sfdisk/dos-sizes-vs-gaps
new file mode 100644
index 000000000..a3eb79020
--- /dev/null
+++ b/tests/expected/sfdisk/dos-sizes-vs-gaps
@@ -0,0 +1,26 @@
+Checking that no-one is using this disk right now ... OK
+
+Disk <removed>: 50 MiB, 52428800 bytes, 102400 sectors
+Disk model: scsi_debug      
+Units: sectors of 1 * 512 = 512 bytes
+Sector size (logical/physical): 512 bytes / 4096 bytes
+I/O size (minimum/optimal): 4096 bytes / <removed> bytes
+
+>>> Created a new disklabel.
+<removed>1: Created a new partition <removed>.
+<removed>2: Created a new partition <removed>.
+<removed>3: Created a new partition <removed>.
+<removed>4: Done.
+
+New situation:
+Disklabel type: dos
+Disk identifier: <removed>
+
+Device     Boot Start   End Sectors   Size Id Type
+<removed>1        2048  3070    1023 511.5K 83 Linux
+<removed>2        4096  8190    4095     2M 83 Linux
+<removed>3        8192 16382    8191     4M 83 Linux
+
+The partition table has been altered.
+Calling ioctl() to re-read partition table.
+Syncing disks.
diff --git a/tests/ts/sfdisk/dos b/tests/ts/sfdisk/dos
index a2fd72885..4aa155ce0 100755
--- a/tests/ts/sfdisk/dos
+++ b/tests/ts/sfdisk/dos
@@ -260,4 +260,17 @@ udevadm settle
 ts_finalize_subtest
 
 
+ts_init_subtest "sizes-vs-gaps"
+$TS_CMD_WIPEFS -a ${TS_DEVICE} &> /dev/null
+udevadm settle
+$TS_CMD_SFDISK ${TS_DEVICE} >> $TS_OUTPUT 2>> $TS_ERRLOG <<EOF
+2048 1023 L -
+4096 4095 L -
+8192 8191 L -
+EOF
+ts_fdisk_clean $TS_DEVICE
+udevadm settle
+ts_finalize_subtest
+
+
 ts_finalize
